## erlang 16.b.3-dfsg

=== debian/changelog ===
erlang (1:16.b.3-dfsg-1ubuntu2.2) trusty-security; urgency=medium

  * SECURITY UPDATE: CRLF injection vulnerabilities in the FTP module
    - debian/patches/CVE-2014-1693.patch: check values in
      lib/inets/src/ftp/ftp.erl, /lib/inets/test/ftp_suite_lib.erl.
    - CVE-2014-1693
  * SECURITY UPDATE: padding-oracle attack
    - debian/patches/CVE-2015-2774.patch: re-enable padding check and
      provide option to disable in lib/ssl/doc/src/ssl.xml,
      lib/ssl/src/dtls_record.erl, lib/ssl/src/ssl.erl,
      lib/ssl/src/ssl_cipher.erl, lib/ssl/src/ssl_internal.hrl,
      lib/ssl/src/ssl_record.erl, lib/ssl/src/tls_connection.erl,
      lib/ssl/src/tls_record.erl, lib/ssl/test/ssl_cipher_SUITE.erl.
    - CVE-2015-2774
  * SECURITY UPDATE: Adaptive Chosen Ciphertext attack in TLS server
    - debian/patches/CVE-2017-1000385.patch: add countermeasurements for
      Bleichenbacher attack in lib/ssl/src/ssl_connection.erl,
      lib/ssl/src/ssl_connection.hrl, lib/ssl/src/tls_connection.erl.
    - CVE-2017-1000385

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 07 Dec 2017 08:47:37 -0500

erlang (1:16.b.3-dfsg-1ubuntu2.1) trusty; urgency=medium

  * Enable IPv6 support in epmd (LP: #1312507), supporting use in IPv6
    only environments:
    - d/rules: Use "-DEPMD6" in CPPFLAGS and ensure this is passed to
      relevant bits of the build process.

 -- James Page <james.page@ubuntu.com>  Tue, 12 Aug 2014 17:29:24 +0100

erlang (1:16.b.3-dfsg-1ubuntu2) trusty; urgency=medium

  * Build erlang-base-hipe on ppc64 and ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 10 Jan 2014 13:30:11 +0100

erlang (1:16.b.3-dfsg-1ubuntu1) trusty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - d/patches/fix-pointer-conversion.patch: Remove implicit integer to
      pointer conversion.
    - d/control: Drop libwxgtk3.0-dev build dependency. Wx isn't in main,
      and not supposed to.
    - d/control: Drop erlang-wx binary and associated dependencies from
      other erlang-* packages.
    - d/rules: Add "+debug_info" to ERL_COMPILE_FLAGS for debug builds.
    - d/p/bytecode-compat.patch: Specify source/target = 1.5 when compiling
      Java source code.

 -- James Page <james.page@ubuntu.com>  Mon, 06 Jan 2014 11:13:39 +0000

erlang (1:16.b.3-dfsg-1) unstable; urgency=low

  * New upstream release.
  * Refreshed patches.
  * Removed patch wich fixes segfault in erlang-wx because it is applied
    upstream.
  * Removed link diameterc.1.gz because the original manpage is renamed
    from diameter-compile.1.gz to diameterc.1.gz.

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 12 Dec 2013 12:03:35 +0400

erlang (1:16.b.2-dfsg-2ubuntu1) trusty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - d/patches/fix-pointer-conversion.patch: Remove implicit integer to
      pointer conversion.
    - d/control: Drop libwxgtk3.0-dev build dependency. Wx isn't in main,
      and not supposed to.
    - d/control: Drop erlang-wx binary and associated dependencies from
      other erlang-* packages.
    - d/rules: Add "+debug_info" to ERL_COMPILE_FLAGS for debug builds.
    - d/p/bytecode-compat.patch: Specify source/target = 1.5 when compiling
      Java source code.

 -- James Page <james.page@ubuntu.com>  Thu, 28 Nov 2013 10:47:24 +0000

erlang (1:16.b.2-dfsg-2) unstable; urgency=low

  * Switched to wxWidgets 3.0 from 2.8 for erlang-wx application.
  * Fixed segfault on adding items to a wxListBox widget (reproducible with
    wxWidgets 3.0).
  * Added new erlang-dbg package with symbol files for libraries and
    binaries in the other packages (except erlang-base-hipe).

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 21 Nov 2013 14:51:50 +0400

erlang (1:16.b.2-dfsg-1ubuntu1) trusty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - d/patches/fix-pointer-conversion.patch: Remove implicit integer to
      pointer conversion.
    - d/control: Drop libwxgtk2.8-dev build dependency. Wx isn't in main,
      and not supposed to.
    - d/control: Drop erlang-wx binary and associated dependencies from
      other erlang-* packages.
    - d/rules: Add "+debug_info" to ERL_COMPILE_FLAGS for debug builds.
    - d/p/bytecode-compat.patch: Specify source/target = 1.5 when compiling
      Java source code.

 -- James Page <james.page@ubuntu.com>  Mon, 11 Nov 2013 16:54:10 +0000

erlang (1:16.b.2-dfsg-1) unstable; urgency=low

  * New upstream release.
  * Removed patches for odbcserver and dets fixes because the bugs were
    fixed upstream.
  * Limited number of simultaneous jobs to 4 to use less build resources
    which makes build easier on systems with less memory.
  * Bumped debhelper compatibility version to 8.
  * Use dh_lintian to install lintian overrides.

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 19 Sep 2013 22:19:04 +0400

erlang (1:16.b.1-dfsg-5) unstable; urgency=low

  * Require libsctp-dev in build dependencies for all linux architectures
    (closes: #634614).
  * Added patch by upstream which fixes bad_object_header errors in dets
    (closes: #720415).
  * Ensure that Java bytecode is compatible with Java 1.5.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 24 Aug 2013 00:24:27 +0400
