=== debian/watch ===
# Watch control file for uscan

# Compulsory line, this is a version 3 file
version=3

opts=dversionmangle=s/-dfsg\d*$//,uversionmangle=tr/[A-Z]/[a-z]/;s/\.$// \
  http://www.erlang.org/download/otp_src_R(\d*)([A-Z]*)(?:-?(\d*))?.tar.gz
